#!/usr/bin/perl

  use DBI;

  require '../../apache-lib.pl';
  require '../../../guardiandigital-lib.pl';

  &ReadParse();
  if (!$in{'update_store'}) {
    if (!$in{'preview'}) {
      ### Get the setsite() routine to get configuration.  Store in $site.
      $site_pm = "/home/httpd/$in{'store'}/conf/site.pm";
      do $site_pm;
      $site = setsite();

      if ($site->{'payprocess'} ne "none") {

        open CYBERCASH, "/home/httpd/$in{'store'}/conf/merchant_conf";
          while (<CYBERCASH>) {
            chomp $_;

            if ($_ =~ m/^[A-Z]/) { 
              ($key, $value) = split /\s+\=\s+/, $_;

              $CC{$key} = $value;
            }
          }
        close CYBERCASH;

      }
      else {
        &PrintError("You do not currently have Cash Register enabled.");
        exit;
      }
    }
    else {
      ### DECODE PREVIEW VARIABLES
    }

    ### Good ol' header.
    &header("Edit Store:  Cash Register Configuration", 0);

    print <<EOF01;
<FORM ACTION="save_cashregister.cgi" METHOD="POST">
<INPUT TYPE=HIDDEN NAME=store VALUE=$in{'store'}>
<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Edit Cash Register Configuration</B></DIV></TD></TR>
  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    Below you can change your Cash Register settings for this store.

    <P><B>Clicking on "Update Store" will make the changes take effect.</B>
  </TD></TR>

 <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=0>
      <TR $tb><TD COLSPAN="2">
        <DIV CLASS="thead"><B>Cash Register Configuration</B></DIV>
      </TD></TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Type</TD>
        <TD><DIV CLASS=toolfont><SELECT NAME="MCK_TYPE">
EOF01

  if ($CC{'MCK_TYPE'} eq "fulfillment") {
    print "         <OPTION VALUE=\"\">Normal</OPTION>\n";
    print "         <OPTION VALUE=\"fulfillment\" SELECTED>Fulfillment</OPTION>\n";
  }
  else {
    print "         <OPTION VALUE=\"\" SELECTED>Normal</OPTION>\n";
    print "         <OPTION VALUE=\"fulfillment\">Fulfillment</OPTION>\n";
  }


print <<EOF02;
        </SELECT></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>CyberCash User ID</TD>
        <TD><INPUT TYPE=TEXT NAME=CYBERCASH_ID SIZE=40 VALUE="$CC{'CYBERCASH_ID'}"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Merchant Key</TD>
        <TD><INPUT TYPE=TEXT NAME=MERCHANT_KEY SIZE=40 VALUE="$CC{'MERCHANT_KEY'}"></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=nbody>
          <INPUT TYPE=SUBMIT NAME="update_store" VALUE="Update Store">
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE></CENTER></FORM><P>
EOF02

    ### Good ol' footer.
    &ryanFooter("/VHost/opensales/edit/");
    exit;
  }

  ### ############################ #############################################
  ### We want to update the store. #############################################
  ### ############################ #############################################
  else {

exit;

    ### Get the setsite() routine to get configuration.  Store in $site.
    $site_pm = "/home/httpd/$in{'store'}/conf/site.pm";
    do $site_pm;
    $site = setsite();
    $store = $in{'store'};


    $sitename                           = $in{'sitename'};
    $admin_pass                         = $in{'admin_pass'};
    $sitename_def                       = $site->{'sitename'};
    $customer_service_email_address     = $in{'customer_service_email_address'};
    $customer_service_email_address_def = $site->{'customer_service_email_address'};
    $order_email_address                = $in{'order_email_address'};
    $order_email_address_def            = $site->{'order_email_address'};
    $webmaster_email_address            = $in{'webmaster_email_address'};
    $webmaster_email_address_def        = $site->{'webmaster_email_address'};
    $payprocess                         = $in{'payprocess'};
    $payprocess_def                     = $site->{'payprocess'};
    $storestate                         = $in{'storestate'};
    $storestate_def                     = $site->{'storestate'};
    $taxrate                            = $in{'taxrate'};
    $taxrate_def                        = $site->{'taxrate'};
    $site_dbiuser                       = $in{'site_dbiuser'};
    $site_dbiuser_def                   = $site->{'site_dbiuser'};
    $site_dbipwd                        = $in{'site_dbipwd'};
    $site_dbipwd_def                    = $site->{'site_dbipwd'};
    $replyto                            = $in{'replyto'};
    $replyto_def                        = $site->{'replyto'};

    $hash_key                           = $site->{'hash_key'};
    $site_database                      = $site->{'site_database'};



    $STORENAME = "/home/httpd/$site_database";

    ### ########################################################################
    ### Generate conf/database.conf. ###########################################
    ### ########################################################################
    &obtain_lock("$STORENAME/conf/database.conf");
    open DATABASE, ">$STORENAME/conf/database.conf";

    print DATABASE <<DATABASE_EOF;
site_datadriver  mysql
site_database_serv  localhost
site_dbiuser  $site_dbiuser
site_dbipwd  $site_dbipwd
site_database  $site_database
DATABASE_EOF

    close DATABASE;
    &release_lock("$STORENAME/conf/database.conf");


    ### ########################################################################
    ### Generate conf/machine.conf. ############################################
    ### ########################################################################
    &obtain_lock("$STORENAME/conf/machine.conf");
    open MACHINE, ">$STORENAME/conf/machine.conf";

    print MACHINE <<MACHINE_EOF;
sitedomain  .0.0.1
siteserver  127
sitessldomain  .0.0.1
sitesslserver  127
ssl_prefix  https
mailserver  /usr/bin/sendmail
replyto  $replyto
\$sr  /home/httpd
MACHINE_EOF

    close MACHINE;
    &release_lock("$STORENAME/conf/machine.conf");


    ### ########################################################################
    ### Generate conf/site.conf. ###############################################
    ### ########################################################################
    &obtain_lock("$STORENAME/conf/site.conf");
    open SITE, ">$STORENAME/conf/site.conf";

    print SITE <<SITE_EOF;
sitename  $sitename
sitecode  m
site_background
site_limit_jit  5
site_limit_all  5
maxtopnav  7
site_sku_totlen  8
site_sku_prelen  3
site_sku_sclen  1
site_sku_numlen  4

customer_service_email_address  $customer_service_email_address
order_email_address  $order_email_address
webmaster_email_address  $webmaster_email_address

interfaces  html
payprocess  $payprocess

hash_key  $hash_key

storestate  $storestate
taxrate  $taxrate

om_locale_lang_def  eng
om_locale_lang_act
om_locale_lang_inact
om_locale_curr_def  USD
om_locale_curr_act
currency_symbol  \$
SITE_EOF

    close SITE;
    &release_lock("$STORENAME/conf/site.conf");




    ### Get the root password.
    open FILE, "/etc/webtool/SystemManager/config";
      while (<FILE>) { if ($_ =~ m/^pass\=(.*)$/) { $dbi_pass = $1; } }
    close FILE;

    ### Make the connection to the DBMS on localhost.
    use DBI;
    $dbh = DBI->connect("DBI:mysql:host=localhost", "root", "$dbi_pass");


    ### We need to update the database username.
    if ($site_dbiuser ne $site_dbiuser_def) {
      $rv = $dbh->do("UPDATE mysql.user SET User = '$site_dbiuser'
                      WHERE User = '$site_dbiuser_def'");

      $rv = $dbh->do("UPDATE mysql.db SET User = '$site_dbiuser'
                      WHERE User = '$site_dbiuser_def'");
    }
    
    ### We need to update the database password.
    if ($site_dbipwd ne $site_dbipwd_def) {
      $rv = $dbh->do("UPDATE mysql.user SET Password = PASSWORD('$site_dbipwd')
                      WHERE User = '$site_dbiuser'");
    }


    ### Update the admin pass.
    $dbh->do("UPDATE $store.contacts SET passwd = '$admin_pass' WHERE uname = 'admin'");

    ### Reload grant tables.
    $rv = $dbh->do("FLUSH PRIVILEGES");

    ### Disconnect from the DBMS.
    $dbh->disconnect();


    ### Re-establish ownership.
    system "chown -R www.www /home/httpd/$site_database";

    ### ########################################################################
    ### Re-generate site.pm, and restart the daemon. ##########################
    ### ########################################################################
    chdir "/home/httpd/$site_database";

    system "crons/update_conf.pl";
    system "crons/generate_site.pl";
    system "chmod 660 conf/*";
    system "chmod 640 conf/site.pm conf/merchant_conf";


    ### Clean and save the environment.
    my %ENV_RESTORE;
    %ENV_RESTORE  =  &clean_env();

      ### Restart the daemon.
      system "/etc/init.d/httpd restart";

    ### Restore the environment.
    &restore_env(%ENV_RESTORE);


    &redirect("/VHost/opensales/edit/");
  }
