#!/usr/bin/perl

  use DBI;

  require '../../apache-lib.pl';
  require '../../../guardiandigital-lib.pl';

  &ReadParse();

  $num = 0;

  ### Get the info from httpd.conf.
  $apache_conf = &get_config();
  @virt = &find_directive_struct("VirtualHost", $apache_conf);

  foreach $v (@virt) {
    $INDEX = &indexof($v, @$apache_conf);
    $vconf = &get_config()->[$INDEX];
    ($nvh, $Port) = ($v->{'value'} =~ /^(\S+):(\S+)$/);
    if (!$Port) { $Port = "80"; }

    $docroot = &find_directive_struct("DocumentRoot", $vconf->{'members'});
    $admin   = &find_directive_struct("ServerAdmin", $vconf->{'members'});
    $name    = &find_directive_struct("ServerName", $vconf->{'members'});

    if ($Port == 443) {
      if (-e "$docroot->{'words'}[0]/conf/site.pm") {
        $virtual[$num]->{'URL'} = "https://$name->{'words'}[0]/cgi-bin/om/admin/login.cgi";
        do "$docroot->{'words'}[0]/conf/site.pm";
        my $site = setsite();
        $virtual[$num++]->{'Name'} = $site->{'sitename'};
      }
    }
  }

  ### Good ol' header.
  &header("Configure Store", 0);

    print <<EOF01;
<P><CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Edit Store</B></DIV></TD></TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    Below you can use the AllCommerce management system to edit your store.
  </TD></TR>

 <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

  <TR $tb>
    <TD><DIV CLASS=thead><B>Store Name</B></DIV></TD>
    <TD><DIV CLASS=thead><B>URL</B></DIV></TD>
  </TR>
EOF01

  foreach $y (@virtual) {
    print "  <TR $cb>\n";
    print "    <TD><DIV CLASS=nbody><B>$y->{'Name'}</B></DIV></TD>\n";
    print "    <TD><DIV CLASS=nbody><A HREF=\"$y->{'URL'}\">$y->{'URL'}</A>";
    print "</DIV></TD>\n";
    print "  </TR>\n";
  }

print <<EOF02;
  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

</TABLE></CENTER></FORM><P>
EOF02

  ### Good ol' footer.
  &ryanFooter("/VHost");
