#!/usr/bin/perl

  require '../../apache-lib.pl';
  &ReadParse();

  ### Get the setsite() routine to get configuration.  Store in $site.
  $site_pm = "/home/httpd/$in{'store'}/conf/site.pm";
  do $site_pm;
  $site = setsite();

  ### Get the FQDN from httpd.conf
  $apache_conf = &get_config();
  @virt = &find_directive_struct("VirtualHost", $apache_conf);

  foreach $v (@virt) {
    $INDEX = &indexof($v, @$apache_conf);
    $vconf = &get_config()->[$INDEX];
    ($nvh, $Port) = ($v->{'value'} =~ /^(\S+):(\S+)$/);
    if (!$Port) { $Port = "80"; }

    $docroot = &find_directive_struct("DocumentRoot", $vconf->{'members'});
    $name    = &find_directive_struct("ServerName", $vconf->{'members'});

    if ($Port == 443) {
      if ($docroot->{'words'}[0] eq "/home/httpd/$in{'store'}") {
        $FQDN = $name->{'words'}[0];
      }
    }
  }


  $authority_str    = &hlink("Authority Name", "ssl_authority");
  $email_str        = &hlink("E-Mail Address", "ssl_email");
  $department_str   = &hlink("Department", "ssl_department");
  $organization_str = &hlink("Organization", "ssl_organization");
  $city_str         = &hlink("City", "ssl_city");
  $state_str        = &hlink("State or Province", "ssl_state");
  $country_str      = &hlink("Country", "ssl_country");


  ### My friend 'header'.
  &header("Store Certificate Generation", "");

print <<EOF01;
  <FORM ACTION="do_generate_certificate.cgi" METHOD="POST">
  <INPUT TYPE=HIDDEN NAME=store VALUE="$in{'store'}">
  <INPUT TYPE=HIDDEN NAME=SSLStatus VALUE="$in{'SSLStatus'}">
  <P><CENTER><TABLE BORDER=0 WIDTH=620 CELLPADDING=0 CELLSPACING=0>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Certificate and Key Generation</B></DIV></TD></TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    To create a new certificate/key pair for this store simply enter all of the
    required information below.  If you are unsure of a field click on the
    help link.

    <P>Please note that by creating a new certificiate/key pair here you 
    will overwrite the existing certificate/key pair, if any.
  </TD></TR>

  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=0>

      <TR $tb><TD COLSPAN=2>
        <DIV CLASS=thead><B>New Certificate and Key</B></DIV>
      </TD></TR>

      <TR $cb>
        <td><DIV CLASS=nbody><b>$authority_str</b></td>
        <td><INPUT NAME=commonName SIZE=30 MAXLENGTH=64 VALUE="$FQDN"></td>
      </TR>

      <TR $cb>
        <td><DIV CLASS=nbody><b>$organization_str</b></td>
        <td><INPUT NAME=organizationName SIZE=30 VALUE="$site->{'sitename'}"></td>
      </TR>

      <TR $cb>
        <td><DIV CLASS=nbody><b>$department_str</b></td>
        <td><INPUT NAME=organizationalUnitName SIZE=30></td>
      </TR>

      <TR $cb>
        <td><DIV CLASS=nbody><b>$email_str</b></td>
        <td><INPUT NAME=emailAddress SIZE=30 MAXLENGTH=40></td>
      </TR>

      <TR $cb>
        <td><DIV CLASS=nbody><b>$city_str</b></td>
        <td><INPUT NAME=localityName SIZE=30></td>
      </TR>

      <TR $cb>
        <td><DIV CLASS=nbody><b>$state_str</b></td>
        <td><INPUT NAME=stateOrProvinceName SIZE=15></td>
      </TR>

      <TR $cb>
        <td><DIV CLASS=nbody><b>$country_str</b></td>
        <td><INPUT NAME=countryName SIZE=3 MAXLENGTH=2></td>
      </TR>

      <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

      <TR $cb>
        <TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=nbody>
          <INPUT TYPE=SUBMIT VALUE="Generate Certificate">
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
  </TABLE></CENTER><P>
EOF01

  &ryanFooter("/VHost/opensales/edit/edit_ssl.cgi?store=$in{'store'}");
