#!/usr/bin/perl
# reconfig_form.cgi
# Displays a list of supported modules, and allows the user to pick which
# ones are installed in apache

require './apache-lib.pl';
&ReadParse();
$access{'global'}==1 || &error($text{'reconfig_ecannot'});
&header($text{'reconfig_title'}, "");

# build list of modules compiled into apache
($ver, $mods) = &httpd_info($config{'httpd_path'});
if (!$ver) {
	print "<CENTER><TABLE BORDER=\"0\" WIDTH=\"620\">\n";
	print "<TR><TD>\n";
	print &text('reconfig_ever', "<tt>$config{'httpd_path'}</tt>",
		    "/config.cgi?$module_name"),"<p>\n";
	print "</TD></TR>\n";
	print "</TABLE></CENTER>\n\n";
	&ryanFooter("/", $text{'index'});
	exit;
	}
foreach $m (@$mods) {
	if (-r "$m.pl") { $inst{$m}++; }
	}

# build list of dynamically loaded modules
$conf = &get_config();
foreach $l (&find_directive_struct("LoadModule", $conf)) {
	if ($l->{'words'}->[1] =~ /(mod_\S+)\.so/ && -r "$1.pl") {
		$inst{$1}++;
		}
	elsif ($l->{'words'}->[1] =~ /lib([^\/\s]+)\.so/ && -r "mod_$1.pl") {
		$inst{"mod_$1"}++;
		}
	}

# build list of supported modules
push(@mods, "core");
opendir(DIR, ".");
foreach $f (readdir(DIR)) {
	if ($f =~ /^(mod_\S+)\.pl$/) { push(@mods, $1); }
	}
closedir(DIR);

if (!$in{'vol'}) {
	print "<CENTER><TABLE BORDER=\"0\" WIDTH=\"620\">\n";
	print "<TR><TD>\n";
	print $text{'reconfig_desc1'};
	print "</TD></TR>\n";
	print "</TABLE></CENTER>\n\n";
	}
else {
	print "<CENTER><TABLE BORDER=\"0\" WIDTH=\"620\">\n";
	print "<TR><TD>\n";
	print $text{'reconfig_desc2'};
	print "</TD></TR>\n";
	print "</TABLE></CENTER>\n\n";
	}
print "<p> <form action=reconfig.cgi>\n";
print "<input type=hidden name=size value=$in{'size'}>\n";
print "<input type=hidden name=ver value=\"$ver\">\n";
print "<CENTER><table width=620>\n";
for($i=0; $i<@mods; $i++) {
	if ($i%4 == 0) { print "<tr>\n"; }
	print "<td><input type=checkbox name=mods value=$mods[$i] ",
	      ($inst{$mods[$i]} ? "checked" : ""),"> $mods[$i]</td>\n";
	if ($i%4 == 3) { print "</tr>\n"; }
	}
print "<TR><TD><input type=submit value=\"$text{'reconfig_ok'}\"></form>\n";
print "</TD></TR></table></CENTER>\n";

if ($in{'vol'}) { &ryanFooter(""); }
else { &ryanFooter("/"); }

