#!/usr/bin/perl

  require '../../apache-lib.pl';

  ### Good ol' header.
  &header("Setup a Store:  Step 1 of 3", "");

  ### Build help link strings.
  $fqdn_help       = hlink("Fully-Qualified Domain Name", "FQDN");
  $storename_help  = hlink("Storename Identifier", "STORENAME");
  $adminmail_help  = hlink("Administrator E-Mail Address", "AdminEmail");
  $storeuser_help  = hlink("Store User Name", "Store_UN");
  $storegroup_help = hlink("Store Group Name", "Store_GN");

  ### Get all of the user names.
  $users_str  = "<SELECT NAME=\"STORE_USERNAME\">\n";
  $users_str .= "  <OPTION>Please Select</OPTION>\n";
    setpwent();
      while (@tmp = getpwent()) {
        if ($tmp[2] >= 500) {
          $users_str .= "  <OPTION>$tmp[0]</OPTION>\n";
        }
      }
    endpwent();
  $users_str .= "</SELECT>\n";

  ### Get all of the group names.
  $groups_str  = "<SELECT NAME=\"STORE_GROUPNAME\">\n";
  $groups_str .= "  <OPTION>Please Select</OPTION>\n";
    setgrent();
      while (@tmp = getgrent()) {
        if ($tmp[2] >= 100) {
          $groups_str .= "  <OPTION>$tmp[0]</OPTION>\n";
        }
      }
    endgrent();
  $groups_str .= "</SELECT>\n";

  print <<EOF;
  <FORM ACTION="setup_allcommerce.cgi" METHOD="POST">
  <INPUT TYPE="HIDDEN" NAME="BASEDIR" VALUE="/home/httpd" CELLSPACING=0>

  <CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING="0" CELLSPACING=0>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Setup a Store</B></DIV></TD></TR>
  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    Below is the webserver configuration portion of setting up a new store.

    <UL>
      <LI><B>Fully-Qualified Domain Name</B> is the full domain name.</LI>
      <LI><B>Storename Identifier</B> is a single string which will be used to identify the store.
      <LI><B>Administrator E-Mail Address</B> is the email address of the system administrator.</LI>
      <LI><B>Store User Name</B> local user who owns all of the files associated with this store.</LI>
      <LI><B>Store Group Name</B> local group who owns all of the files associated with this store.</LI>
    </UL>

    <P><B>The next step is the AllCommerce configuration.</B>
  </TD></TR>

  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=0>
      <TR $tb>
        <TD COLSPAN="2"><DIV CLASS="thead"><B>Webserver Configuration</B></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$fqdn_help</B></DIV></TD>
        <TD><INPUT TYPE="TEXT" NAME="FQDN" SIZE="30"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$storename_help</B></DIV></TD>
        <TD><INPUT TYPE="TEXT" NAME="STORENAME" SIZE="16" MAXLENGTH="16"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$adminmail_help</B></DIV></TD>
        <TD><INPUT TYPE="TEXT" NAME="ADMIN_EMAIL" SIZE="30"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$storeuser_help</B></DIV></TD>
        <TD><DIV CLASS="toolfont">$users_str</DIV></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS="nbody"><B>$storegroup_help</B></DIV></TD>
        <TD><DIV CLASS="toolfont">$groups_str</DIV></TD>
      </TR>

      <TR $cb>
        <TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=nbody>
          <INPUT TYPE="SUBMIT" VALUE="Next Step">
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
  </TABLE></CENTER></FORM><P>
EOF

  ### Good ol' footer.
  &ryanFooter("/VHost");
