#!/usr/bin/perl

  require '../../apache-lib.pl';
  require '../../../guardiandigital-lib.pl';

  &ReadParse();

  if (!$in{'update_store'}) {
    if (!$in{'preview'}) {
      ### Get the setsite() routine to get configuration.  Store in $site.
      $site_pm = "/home/httpd/$in{'store'}/conf/site.pm";
      do $site_pm;
      $site = setsite();

      ### Variables for conf/site.conf.
      $sitename                       = $site->{'sitename'};
      $customer_service_email_address = $site->{'customer_service_email_address'};
      $order_email_address            = $site->{'order_email_address'};
      $webmaster_email_address        = $site->{'webmaster_email_address'};
      $payprocess                     = $site->{'payprocess'};
      $storestate                     = $site->{'storestate'};
      $taxrate                        = $site->{'taxrate'};

      ### Variables for conf/database.conf.
      $site_dbiuser                   = $site->{'site_dbiuser'};
      $site_dbipwd                    = $site->{'site_dbipwd'};

      ### Variables for conf/machine.conf.
      $replyto                        = $site->{'replyto'};

      ### Make the connection to the DBMS on localhost.
      use DBI;
      $store = $in{'store'};

      $dbh = DBI->connect("DBI:mysql:database=$store;host=localhost",
                          "$site_dbiuser", "$site_dbipwd");

      if ($dbh) {
        $sth = $dbh->prepare("SELECT passwd FROM contacts WHERE uname='admin'");
        $sth->execute();
          $ref = $sth->fetchrow_hashref();
          $admin_pass = $ref->{'passwd'};
        $sth->finish();

        $dbh->disconnect();
      }
    }
    else {
      ### Variables for conf/site.conf.
      $sitename                       = $in{'sitename'};
      $admin_pass                     = $in{'admin_pass'};
      $customer_service_email_address = $in{'customer_service_email_address'};
      $order_email_address            = $in{'order_email_address'};
      $webmaster_email_address        = $in{'webmaster_email_address'};
      $payprocess                     = $in{'payprocess'};
      $storestate                     = $in{'storestate'};
      $taxrate                        = $in{'taxrate'};

      ### Variables for conf/database.conf.
      $site_dbiuser                   = $in{'site_dbiuser'};
      $site_dbipwd                    = $in{'site_dbipwd'};

      ### Variables for conf/machine.conf.
      $replyto                        = $in{'replyto'};
    }

    ### Good ol' header.
    &header("Edit Store", 0);

    print <<EOF01;
<FORM ACTION="edit_allcommerce.cgi" METHOD="POST">
<INPUT TYPE=HIDDEN NAME=store VALUE=$in{'store'}>
<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=620>
  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Edit AllCommerce Configuration</B></DIV></TD></TR>
  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>
    Below you can change your AllCommerce settings for this store.

    <P><B>Clicking on "Update Store" will make changes take effect.</B>
  </TD></TR>

 <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>
  <TR $cb>
    <TD WIDTH=20>&nbsp;</TD>
    <TD>
      <TABLE BORDER=0 WIDTH=100% CELLSPACING=0 CELLPADDING=0>
      <TR $tb><TD COLSPAN="2">
        <DIV CLASS="thead"><B>AllCommerce Configuration</B></DIV>
      </TD></TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Site Name</TD>
        <TD><INPUT TYPE=TEXT NAME=sitename SIZE=30 VALUE="$sitename"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Adminsitrative Password</TD>
        <TD>
          <INPUT TYPE=TEXT NAME=admin_pass SIZE=16 VALUE="$admin_pass" MAXLENGTH=16%
        </TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Customer Service E-Mail</TD>
        <TD><INPUT TYPE=TEXT NAME=customer_service_email_address SIZE=30 VALUE="$customer_service_email_address"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Order E-Mail</TD>
        <TD><INPUT TYPE=TEXT NAME=order_email_address SIZE=30 VALUE="$order_email_address"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Webmaster E-Mail</TD>
        <TD><INPUT TYPE=TEXT NAME=webmaster_email_address SIZE=30 VALUE="$webmaster_email_address"></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Pay Process</TD>
        <TD><DIV CLASS=nbody><SELECT NAME="payprocess">
EOF01
  #print " <TD><INPUT TYPE=TEXT NAME=payprocess SIZE=30 VALUE=$payprocess></TD>";

  if ($payprocess eq "none") {
    print "<OPTION VALUE=none SELECTED>none</OPTION>\n";
    print "<OPTION VALUE=cybercash>CyberCash</OPTION>\n";
  }
  else {
    print "<OPTION VALUE=none>none</OPTION>\n";
    print "<OPTION VALUE=cybercash SELECTED>CyberCash</OPTION>\n";
  }

  print <<EOF02;
        </SELECT></TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Store State</TD>\
        <TD>
          <INPUT TYPE=TEXT NAME=storestate SIZE=2 VALUE="$storestate" MAXLENGTH=2>
        </TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Tax Rate</TD>
        <TD>
          <INPUT TYPE=TEXT NAME=taxrate SIZE=5 VALUE="$taxrate" MAXLENGTH=5>%
        </TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Database Username</TD>
        <TD>
          <INPUT TYPE=TEXT NAME=site_dbiuser SIZE=16 VALUE="$site_dbiuser" MAXLENGTH=16>
        </TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Database Password</TD>
        <TD>
          <INPUT TYPE=TEXT NAME=site_dbipwd SIZE=16 VALUE="$site_dbipwd" MAXLENGTH=16>
        </TD>
      </TR>

      <TR $cb>
        <TD><DIV CLASS=nbody><B>Reply To E-Mail</TD>
        <TD><INPUT TYPE=TEXT NAME=replyto SIZE=30 VALUE="$replyto"></TD>
      </TR>

      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>
      <TR $cb> <TD COLSPAN="2"> &nbsp; </TD> </TR>

      <TR $cb>
        <TD COLSPAN=2 ALIGN=RIGHT><DIV CLASS=nbody>
          <INPUT TYPE=SUBMIT NAME="update_store" VALUE="Update Store">
          <INPUT TYPE=SUBMIT NAME="preview" VALUE="Preview Changes">
        </TD>
      </TR>
      </TABLE>
    </TD>
  </TR>
</TABLE></CENTER></FORM><P>
EOF02

    ### Good ol' footer.
    &ryanFooter("/VHost/opensales/edit/");
    exit;
  }

  ### ############################ #############################################
  ### We want to update the store. #############################################
  ### ############################ #############################################
  else {

    ### Get the setsite() routine to get configuration.  Store in $site.
    $site_pm = "/home/httpd/$in{'store'}/conf/site.pm";
    do $site_pm;
    $site = setsite();
    $store = $in{'store'};


    $sitename                           = $in{'sitename'};
    $admin_pass                         = $in{'admin_pass'};
    $sitename_def                       = $site->{'sitename'};
    $customer_service_email_address     = $in{'customer_service_email_address'};
    $customer_service_email_address_def = $site->{'customer_service_email_address'};
    $order_email_address                = $in{'order_email_address'};
    $order_email_address_def            = $site->{'order_email_address'};
    $webmaster_email_address            = $in{'webmaster_email_address'};
    $webmaster_email_address_def        = $site->{'webmaster_email_address'};
    $payprocess                         = $in{'payprocess'};
    $payprocess_def                     = $site->{'payprocess'};
    $storestate                         = $in{'storestate'};
    $storestate_def                     = $site->{'storestate'};
    $taxrate                            = $in{'taxrate'};
    $taxrate_def                        = $site->{'taxrate'};
    $site_dbiuser                       = $in{'site_dbiuser'};
    $site_dbiuser_def                   = $site->{'site_dbiuser'};
    $site_dbipwd                        = $in{'site_dbipwd'};
    $site_dbipwd_def                    = $site->{'site_dbipwd'};
    $replyto                            = $in{'replyto'};

    $hash_key                           = $site->{'hash_key'};
    $site_database                      = $site->{'site_database'};



    $STORENAME = "/home/httpd/$site_database";

    ### ########################################################################
    ### Generate conf/database.conf. ###########################################
    ### ########################################################################
    &obtain_lock("$STORENAME/conf/database.conf");
    open DATABASE, ">$STORENAME/conf/database.conf";

    print DATABASE <<DATABASE_EOF;
site_datadriver  mysql
site_database_serv  localhost
site_dbiuser  $site_dbiuser
site_dbipwd  $site_dbipwd
site_database  $site_database
DATABASE_EOF

    close DATABASE;
    &release_lock("$STORENAME/conf/database.conf");


    ### ########################################################################
    ### Generate conf/machine.conf. ############################################
    ### ########################################################################
    &obtain_lock("$STORENAME/conf/machine.conf");

      ### Read the old file.
      open MACHINE, "$STORENAME/conf/machine.conf";
        while (<MACHINE>) { chomp $_; push @machine_conf, $_; }
      close MACHINE;

      ### Re-write it, with an updated Reply-To address.
      open MACHINE, ">$STORENAME/conf/machine.conf";
        foreach (@machine_conf) {
          if ($_ !~ m/^replyto/) { print MACHINE "$_\n"; }
          else                   { print MACHINE "replyto  $replyto\n"; }
        }
      close MACHINE;
    &release_lock("$STORENAME/conf/machine.conf");


    ### ########################################################################
    ### Generate conf/site.conf. ###############################################
    ### ########################################################################
    &obtain_lock("$STORENAME/conf/site.conf");
    open SITE, ">$STORENAME/conf/site.conf";

    print SITE <<SITE_EOF;
sitename  $sitename
sitecode  m
site_background
site_limit_jit  5
site_limit_all  5
maxtopnav  7
site_sku_totlen  8
site_sku_prelen  3
site_sku_sclen  1
site_sku_numlen  4

customer_service_email_address  $customer_service_email_address
order_email_address  $order_email_address
webmaster_email_address  $webmaster_email_address

interfaces  html
payprocess  $payprocess

hash_key  $hash_key

storestate  $storestate
taxrate  $taxrate

om_locale_lang_def  eng
om_locale_lang_act
om_locale_lang_inact
om_locale_curr_def  USD
om_locale_curr_act
currency_symbol  \$
SITE_EOF

    close SITE;
    &release_lock("$STORENAME/conf/site.conf");




    ### Get the root password.
    open FILE, "/etc/webtool/SystemManager/config";
      while (<FILE>) { if ($_ =~ m/^pass\=(.*)$/) { $dbi_pass = $1; } }
    close FILE;

    ### Make the connection to the DBMS on localhost.
    use DBI;
    $dbh = DBI->connect("DBI:mysql:host=localhost", "root", "$dbi_pass");


    ### We need to update the database username.
    if (($site_dbiuser ne $site_dbiuser_def) && $dbh) {
      $rv = $dbh->do("UPDATE mysql.user SET User = '$site_dbiuser'
                      WHERE User = '$site_dbiuser_def'");

      $rv = $dbh->do("UPDATE mysql.db SET User = '$site_dbiuser'
                      WHERE User = '$site_dbiuser_def'");
    }
    
    ### We need to update the database password.
    if ($site_dbipwd ne $site_dbipwd_def) {
      $rv = $dbh->do("UPDATE mysql.user SET Password = PASSWORD('$site_dbipwd')
                      WHERE User = '$site_dbiuser'");
    }


    ### Update the admin pass.
    $dbh->do("UPDATE $store.contacts SET passwd = '$admin_pass' WHERE uname = 'admin'");

    ### Reload grant tables.
    $rv = $dbh->do("FLUSH PRIVILEGES");

    ### Disconnect from the DBMS.
    $dbh->disconnect();


    ### Re-establish ownership.
    system "chown -R www.www /home/httpd/$site_database";

    ### ########################################################################
    ### Re-generate site.pm, and restart the daemon. ##########################
    ### ########################################################################
    chdir "/home/httpd/$site_database";

    system "crons/update_conf.pl";
    system "crons/generate_site.pl";
    system "chmod 660 conf/*";
    system "chmod 640 conf/site.pm conf/merchant_conf";


    ### Clean and save the environment.
    my %ENV_RESTORE;
    %ENV_RESTORE  =  &clean_env();

      ### Restart the daemon.
      system "/etc/init.d/httpd restart";

    ### Restore the environment.
    &restore_env(%ENV_RESTORE);


    &redirect("/VHost/opensales/edit/");
  }
