#!/usr/bin/perl

  require '../apache-lib.pl';

  ### Extract the configuration files into @conf_files.
  chdir "/etc/webalizer";
  @conf_files = glob "*.conf";


  ### ####################################### ###
  ### Print the header and let the fun begin. ###
  ### ####################################### ###
  &header($text{'index_title'}, "", undef, 1, 1, undef, &restart_button());


  print "<P><CENTER><TABLE WIDTH=620 BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
  print "  <TR $tb><TD COLSPAN=2><DIV CLASS=ttitle><B>Virtual Servers</TD></TR>\n";
  print "  <TR $cb><TD COLSPAN=2><DIV CLASS=nbody>Below is a listing of the ";
  print "virtual servers you currently have on your system.  Please note that ";
  print "this list only includes normal web servers, and not SSL web ";
  print "servers.</TD></TR>\n";

  print "  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>\n";

  print "  <tr $tb>\n";
  print "    <td><DIV CLASS=\"thead\"><b>Site</b></td>\n";
  print "    <td><DIV CLASS=\"thead\"><b>Configuration File</b></td>\n";
  print "  </tr>\n\n";


  ### Iterate through each server and print our info.
  foreach $file (@conf_files) {
    if ($file ne "webalizer.conf") {
      ($site) = ($file =~m/^(.*)\.conf$/);
      $filename = "/etc/webalizer/$file";

      if ($site ne "default_webalizer") {
        print "  <TR $cb>\n";
        print "    <TD><DIV CLASS=nbody>$site</TD>\n";
        print "    <TD><DIV CLASS=nbody><A HREF=\"edit_config.cgi?conf_file=$filename\">$file</A></TD>\n";
        print "  </TR>\n";
      }
    }
  }

  print "  <TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>\n";
  print "</table></CENTER><P>\n";

  ### I'm on my way... home... sweet... home...
  &ryanFooter("/VHost", $text{'index'});
